/*
**      Small-C Preprocessor Ver 1.1    26-Dec-87 cpp0.c
**      Nick Andrew & J.E. Hendrix
**
*/

#include        "cpp.h"

int     sargc;
char    **sargv;

main(argc, argv)
int     argc;
char    *argv[];
{

    sargc = argc;
    sargv = argv;

    iflevel =               /* #if... nesting level = 0 */
    skiplevel =             /* #if... not encountered */
    enstring =              /* not in string */
    encomment =             /* not in comment */
    macptr =                /* clear the macro pool */
    errflag =               /* not skipping errors till ";" */
    eof =                   /* not eof yet */
    filearg =
    quote[1] = 0;

    ccode = 1;              /* enable preprocessing */

    quote[0] = '"';         /* fake a quote literal */
    input = fileptr-1;      /* array of file pointers */

    ask(argc, argv);

    while (++filearg < sargc)     {

        strcpy(pline1, sargv[filearg]);
        if (*pline1 == '-') continue;

        if (openin(pline1) != 0) continue;

        sout(pline1, stderr);
        lout(":", stderr);

        parse();
    }

    fclose(output);
}

/*
**      Parse ... Level 7-6 ... Process text for a file
**
*/

parse()
{

    eof = 0;

    for (;;) {
        preprocess();
        if (eof) break;

        iline = pline2;
        bump(0);

        if (ppline) {
            fputs("Looking for #asm or #include\n",stderr);
            if (match("#asm"))          doasm();
            else if (match("#include")) doinclude();
            else error("Unknown preprocessor line");
        } else {
            lout(iline,output);
         }
     }
}

/*
**      Ask ... get runtime options
*/

ask(argc, argv)
int     argc;
char    *argv[];
{

        listfp = NULL;
        output = stdout;

        if (argc<2) usage();

        while (--argc) {
                argv++;

                if (argv[0][0] != '-')
                        continue;

                switch (argv[0][1])    {

                case 'l':
                case 'L':
                        listfp = stdout;
                        break;

                case 'd':
                case 'D':
                        break;

                default:
                        usage();
                }
        }
}

/*
**      spell out the usage
*/

usage() {
        sout("usage: cpp [-Dname] file ...\n",stderr);
        exit(1);
}

/*
**      open next input file & push on open files stack
*/

int     openin(fn)
char    *fn;
{

    FILE *fp;

    if ((fp = fopen(fn, "r")) == NULL) {
        sout(fn, stderr);
        lout(": open error", stderr);
        return 1;
    }

    *++input = fp;

    return 0;
}

